/*
* Copyright 2020 Kumori systems S.L.
*
* Licensed under the EUPL, Version 1.2 or – as soon they
* will be approved by the European Commission - subsequent
* versions of the EUPL (the "Licence");
* You may not use this work except in compliance with the
* Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl
*
* Unless required by applicable law or agreed to in
* writing, software distributed under the Licence is
* distributed on an "AS IS" basis,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing
* permissions and limitations under the Licence.
 */
// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1beta1 "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/apis_openstack/openstack/v1beta1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeOpenStackClusters implements OpenStackClusterInterface
type FakeOpenStackClusters struct {
	Fake *FakeInfrastructureV1beta1
	ns   string
}

var openstackclustersResource = schema.GroupVersionResource{Group: "infrastructure.cluster.x-k8s.io", Version: "v1beta1", Resource: "openstackclusters"}

var openstackclustersKind = schema.GroupVersionKind{Group: "infrastructure.cluster.x-k8s.io", Version: "v1beta1", Kind: "OpenStackCluster"}

// Get takes name of the openStackCluster, and returns the corresponding openStackCluster object, and an error if there is any.
func (c *FakeOpenStackClusters) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1beta1.OpenStackCluster, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(openstackclustersResource, c.ns, name), &v1beta1.OpenStackCluster{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.OpenStackCluster), err
}

// List takes label and field selectors, and returns the list of OpenStackClusters that match those selectors.
func (c *FakeOpenStackClusters) List(ctx context.Context, opts v1.ListOptions) (result *v1beta1.OpenStackClusterList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(openstackclustersResource, openstackclustersKind, c.ns, opts), &v1beta1.OpenStackClusterList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1beta1.OpenStackClusterList{ListMeta: obj.(*v1beta1.OpenStackClusterList).ListMeta}
	for _, item := range obj.(*v1beta1.OpenStackClusterList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested openStackClusters.
func (c *FakeOpenStackClusters) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(openstackclustersResource, c.ns, opts))

}

// Create takes the representation of a openStackCluster and creates it.  Returns the server's representation of the openStackCluster, and an error, if there is any.
func (c *FakeOpenStackClusters) Create(ctx context.Context, openStackCluster *v1beta1.OpenStackCluster, opts v1.CreateOptions) (result *v1beta1.OpenStackCluster, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(openstackclustersResource, c.ns, openStackCluster), &v1beta1.OpenStackCluster{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.OpenStackCluster), err
}

// Update takes the representation of a openStackCluster and updates it. Returns the server's representation of the openStackCluster, and an error, if there is any.
func (c *FakeOpenStackClusters) Update(ctx context.Context, openStackCluster *v1beta1.OpenStackCluster, opts v1.UpdateOptions) (result *v1beta1.OpenStackCluster, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(openstackclustersResource, c.ns, openStackCluster), &v1beta1.OpenStackCluster{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.OpenStackCluster), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeOpenStackClusters) UpdateStatus(ctx context.Context, openStackCluster *v1beta1.OpenStackCluster, opts v1.UpdateOptions) (*v1beta1.OpenStackCluster, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(openstackclustersResource, "status", c.ns, openStackCluster), &v1beta1.OpenStackCluster{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.OpenStackCluster), err
}

// Delete takes name of the openStackCluster and deletes it. Returns an error if one occurs.
func (c *FakeOpenStackClusters) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteActionWithOptions(openstackclustersResource, c.ns, name, opts), &v1beta1.OpenStackCluster{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeOpenStackClusters) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(openstackclustersResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &v1beta1.OpenStackClusterList{})
	return err
}

// Patch applies the patch and returns the patched openStackCluster.
func (c *FakeOpenStackClusters) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta1.OpenStackCluster, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(openstackclustersResource, c.ns, name, pt, data, subresources...), &v1beta1.OpenStackCluster{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.OpenStackCluster), err
}
